import socket
import threading
import time
import sys

tello_address = ('192.168.10.1', 8889)
local_address = ('你的電腦 IP', 9000)

sock = socket.socket(socket.AF_INET, socket.SOCK_DGRAM)
sock.bind(local_address)

def send(message, delay):
    try:
        sock.sendto(message.encode(), tello_address)
        print('Sending message: ' + message)
    except Exception as e:
        print('Error sending: ' + str(e))
    if message == 'takeoff':  
        delay = 8
    elif message == 'land':  
        delay = 6
        
    time.sleep(delay)
    
def receive():
    while True:
        try:
            response, ip_address = sock.recvfrom(128)
            print('Received message: ' + response.decode(encoding = 'utf-8'))
        except Exception as e:
            sock.close()
            print('socket closed ==> Error receiving: ' + str(e))
            break
      
receiveThread = threading.Thread(target = receive)
receiveThread.daemon = True
receiveThread.start()

print("請輸入 Tello SDK 指令，並按下 'Enter' 鍵，或輸入 'quit' 離開程式。")

while True:
    try: 
        message = input(':: ')
        if 'quit' in message:
            print('Program exited sucessfully')
            sock.close()
            break
    
        send(message, 3)
    
    except KeyboardInterrupt as e:
        sock.close()
        break