import socket
import threading
import time
import tello

tello_address = ('192.168.10.1', 8889)
local_address = ('你的電腦 IP', 9000)
drone = tello.Tello()

sock = socket.socket(socket.AF_INET, socket.SOCK_DGRAM)
sock.bind(local_address)

def send(message, delay):
    try:
        sock.sendto(message.encode(), tello_address)
        print('Sending message: ' + message)
    except Exception as e:
        print('Error sending: ' + str(e))
        if message == 'takeoff':  
            delay = 8
        elif message == 'land':  
            delay = 6
    time.sleep(delay)

def receive():
    while True:
        try:
            response, ip_address = sock.recvfrom(128)
            print('Received message: ' + response.decode(encoding = 'utf-8'))
        except Exception as e:
            sock.close()
            print('socket closed ==> Error receiving: ' + str(e))
            break
 
receiveThread = threading.Thread(target = receive)
receiveThread.daemon = True
receiveThread.start()

box_leg_distance = 100
yaw_angle = 90
yaw_direction = 'cw'
send('command', 2)
send('takeoff', 8)
drone.streamon()

for i in range(4):
    send('forward ' + str(box_leg_distance), 4)
    send('cw ' + str(yaw_angle), 4)
    
drone.streamoff()
send('land', 5)

print('Mission completed successfully!')
sock.close()