import socket
import threading
import time
import tello

tello_address = ('192.168.10.1', 8889)
local_address = ('你的電腦 IP', 9000)
drone = tello.Tello()

sock = socket.socket(socket.AF_INET, socket.SOCK_DGRAM)
sock.bind(local_address)

def send(message, delay = 3):
    try:
        sock.sendto(message.encode(), tello_address)
        print('Sending message: ' + message)
    except Exception as e:
        print('Error sending: ' + str(e))
        if message == 'takeoff':  
            delay = 8
        elif message == 'land':  
            delay = 6
    time.sleep(delay)
    
def receive():
    while True:
        try:
            response, ip_address = sock.recvfrom(128)
            print('Received message: ' + response.decode(encoding = 'utf-8'))
        except Exception as e:
            sock.close()
            print('Error receiving: ' + str(e))
            break

receiveThread = threading.Thread(target = receive)
receiveThread.daemon = True
receiveThread.start()
  
leg_distance = 60
yaw_degrees = 144

send('command', 1)
send('takeoff', 7)
drone.streamon()

for i in range(5):
    send('forward ' + str(leg_distance), 5)
    send('cw ' + str(yaw_degrees), 5)

drone.streamoff()
send('land', 5)

print('Mission completed successfully!')
sock.close()